<?php

namespace Ulmus\User\Authorize;

use Psr\Http\Message\ServerRequestInterface;
use Ulmus\User\Entity\UserInterface;

class BasicAuthentication implements AuthorizeMethodInterface
{
    public function connect(ServerRequestInterface $request): UserInterface|false
    {
        if ( null === $auth = $request->getHeader('Authorization') ) {
            list($method, $userPass) = explode(' ', $auth, 2) + [ null, null ];

            if (! $method ) {
                throw new \InvalidArgumentException("An authentication method must be provided");
            }
            elseif (! $userPass ) {
                throw new \InvalidArgumentException("A base64-encoded 'user:password' value must be provided");
            }
            

            return false;
        }

        return false;
    }

    protected function basicMethod(string $header) : UserInterface|false
    {

    }

}